Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks
Imports System.Net.Http
Imports System.Net
Imports System.IO


Public Class MICR

    Dim BOUNDARY_DEF As String = "=_Part_" + DateTime.Now.Ticks.ToString("x")
    Dim m_MicrSubmissionIndicator, m_NdexSubmissionIndicator As Boolean
    Dim m_MICRResponse, m_MICR_URL, m_UserName, m_Password, m_XMLFilePath As String
    Public Property MicrSubmissionIndicator() As Boolean
        Get
            Return m_MicrSubmissionIndicator
        End Get
        Set(value As Boolean)
            m_MicrSubmissionIndicator = value
        End Set
    End Property
    Public Property NdexSubmissionIndicator() As Boolean
        Get
            Return m_NdexSubmissionIndicator
        End Get
        Set(ByVal value As Boolean)
            m_NdexSubmissionIndicator = value
        End Set
    End Property
    Public Property MICR_URL() As String
        Get
            Return m_MICR_URL
        End Get
        Set(ByVal value As String)
            m_MICR_URL = value
        End Set
    End Property
    Public Property UserName() As String
        Get
            Return m_UserName
        End Get
        Set(ByVal value As String)
            m_UserName = value
        End Set
    End Property
    Public Property Password() As String
        Get
            Return m_Password
        End Get
        Set(ByVal value As String)
            m_Password = value
        End Set
    End Property
    Public Property XMLFilePath() As String
        Get
            Return m_XMLFilePath
        End Get
        Set(ByVal value As String)
            m_XMLFilePath = value
        End Set
    End Property
    Public Property MICRResponse() As String
        Get
            Return m_MICRResponse
        End Get
        Set(ByVal value As String)
            m_MICRResponse = value
        End Set
    End Property
    ''' <summary>
    ''' This function will create the message and send it to the URL for processing
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function ProcessMICRTransaction() As String

        Try
            ' check for the required MICR_URL.
            If Me.MICR_URL = "" OrElse Me.MICR_URL Is Nothing Then
                Return "Please enter the correct URL"
            End If
            ' check for the required User Name.
            If Me.UserName = "" OrElse Me.UserName Is Nothing Then
                Return "Please enter the correct UserName"
            End If
            ' check for the required password.
            If Me.Password = "" OrElse Me.Password Is Nothing Then
                Return "Please enter the correct Password"
            End If
            ' check for the required XML file path.
            ' this will not verify weather the file exists or not
            If Me.XMLFilePath = "" OrElse Me.XMLFilePath Is Nothing Then
                Return "Please enter the correct path of the xml file"
            End If

            'Creating the MICR Request based on the URL
            Dim wr As HttpWebRequest = DirectCast(WebRequest.Create(Me.MICR_URL), HttpWebRequest)
            wr.Method = "POST" 'Setting the type of the HTTP Web Request
            wr.KeepAlive = True
            wr.ContentType = "multipart/related;type=""text/xml"";charset=UTF-8;boundary=""" + Me.BOUNDARY_DEF + """"
            Dim rs As Stream = wr.GetRequestStream() ' Gets the object to use to write request data  

            'Creating the body header
            '"--" should be injected to the boundary definition
            Dim bodyHeader As String = vbCr & vbLf + vbCr & vbLf + "--" + Me.BOUNDARY_DEF + vbCr & vbLf + "Content-Type: text/xml; charset=UTF-8" + vbCr & vbLf + "Content-Transfer-Encoding: 8bit" + vbCr & vbLf + "Content-ID: <rootpart@soapui.org>" + vbCr & vbLf & vbCr & vbLf & vbCr & vbLf
            Dim bytesHeader As Byte() = System.Text.Encoding.UTF8.GetBytes(bodyHeader)
            'Sending the body Header
            rs.Write(bytesHeader, 0, bytesHeader.Length)

            'Creating the request body
            Dim strRequestBody As String = "<soapenv:Envelope xmlns:mic=""http://www.michigan.gov/msp/micrmidexmessages"" xmlns:soapenv=""http://schemas.xmlsoap.org/soap/envelope/"">" & vbCr & vbLf & "<soapenv:Header><wsse:Security soapenv:mustUnderstand=""1"" xmlns:wsse=""http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"" xmlns:wsu=""http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd""><wsse:UsernameToken wsu:Id=""UsernameToken-1E5525AC524632E089144734286406971""><wsse:Username>YOUR_USERNAME</wsse:Username><wsse:Password Type=""http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-username-token-profile-1.0#PasswordText"">YOUR_PASSWORD</wsse:Password><wsse:Nonce EncodingType=""http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-soap-message-security-1.0#Base64Binary"">OVXwnkMlmkeBY/OEZX1/yw==</wsse:Nonce><wsu:Created>2015-11-12T15:41:04.069Z</wsu:Created></wsse:UsernameToken></wsse:Security></soapenv:Header>" & vbCr & vbLf & "<soapenv:Body>" & vbCr & vbLf & "<mic:MicrMidexRequest>" & vbCr & vbLf & "<mic:MicrSubmissionIndicator>" & Me.MicrSubmissionIndicator & "</mic:MicrSubmissionIndicator>" & vbCr & vbLf & "<mic:NdexSubmissionIndicator>" & Me.NdexSubmissionIndicator & "</mic:NdexSubmissionIndicator>" & vbCr & vbLf & "</mic:MicrMidexRequest>" & vbCr & vbLf & "</soapenv:Body>" & vbCr & vbLf & "</soapenv:Envelope>" & vbCr & vbLf
            'Sending the soap Header
            Dim bytesRequestBody As Byte() = System.Text.Encoding.UTF8.GetBytes(strRequestBody)
            rs.Write(bytesRequestBody, 0, bytesRequestBody.Length)


            'Creating header for the xml attachment 
            '"--" should be injected to the boundary definition
            Dim strXMLHeaderFile As String = "--" + Me.BOUNDARY_DEF + vbCr & vbLf + "Content-Type: text/xml;charset=Cp1252;name=myfile.xml" + vbCr & vbLf & "Content-Transfer-Encoding:7bit " & vbCr & vbLf & "Content-ID: <micrmidexdata> " & vbCr & vbLf & "Content-Disposition: attachment; name=""myfile.xml""; filename=""myfile.xml"" " & vbCr & vbLf & vbCr & vbLf
            Dim headerbytes As Byte() = System.Text.Encoding.UTF8.GetBytes(strXMLHeaderFile)
            rs.Write(headerbytes, 0, headerbytes.Length)


            ' Attaching the file.
            Dim fileStream As New FileStream(Me.XMLFilePath, FileMode.Open, FileAccess.Read)
            Dim buffer(4096) As Byte
            Dim bytesRead As Integer = 0
            'Reading the 4096 bytes and writing to request data stream
            Do
                bytesRead = fileStream.Read(buffer, 0, buffer.Length)
                If bytesRead > 0 Then
                    rs.Write(buffer, 0, bytesRead)
                End If
            Loop While bytesRead > 0

            'closing the file stream
            fileStream.Close()
            Dim trailer As Byte() = System.Text.Encoding.ASCII.GetBytes(vbCr & vbLf & "--" + Me.BOUNDARY_DEF + "--" & vbCr & vbLf)
            rs.Write(trailer, 0, trailer.Length)

            ' getting the response back.
            Dim wresp As WebResponse = Nothing
            Try
                wresp = wr.GetResponse()
                Dim StreamMICRResponse As Stream = wresp.GetResponseStream()
                Dim reader As New StreamReader(StreamMICRResponse)
                ' Saving the response to the string
                Me.MICRResponse = reader.ReadToEnd()
            Catch ex As Exception
                Return ex.Message
                If wresp IsNot Nothing Then
                    wresp.Close() ' closing the stream
                    wresp = Nothing
                End If
            Finally
                wr = Nothing
            End Try
        Catch ex As Exception
            Return ex.Message
        End Try

        Return Me.MICRResponse ' returning the reponse to the calling application.

    End Function

  

 
End Class
